property script_author : "Jonathan Nathan"
property script_name : "Jumpy"
property script_version : "1.0"
property script_release_date : date "Thursday, September 18, 2003 12:00:00 AM"
property script_copyright : ("" & ((year of script_release_date) as string) & " " & script_author & ". All rights reserved.")
property script_thanks : ""

property allow_quitting : false
property win_margin : 20

on launched the_object
	my update_status("launched " & (name of the_object as string))
	activate
	show window "main"
	set allow_quitting to true
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as string
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			center
		end tell
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & script_release_date as string)
			set contents of text field "copyright" to (script_copyright)
			set contents of text field "thanks" to (script_thanks)
		end tell
		
	end if
end awake from nib

on choose menu item the_object
	set object_name to name of the_object as string
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		show window "about"
		
	else if object_name = "quit" then
		quit
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as string
	my update_status("clicked " & object_name)
	if object_name = "jumpy" then
		beep
		display dialog "You caught me!" buttons {"OK"} default button 1 with icon 1 giving up after 10
	end if
end clicked

on mouse entered the_object event the_event
	set object_name to name of the_object as string
	my update_status("mouse entered " & object_name)
	if object_name = "jumpy" then
		copy bounds of window of the_object to {x, y, x2, y2}
		copy {(x2 - x), (y2 - y)} to {win_width, win_height}
		copy bounds of the_object to {x, y, x2, y2}
		copy {(x2 - x), (y2 - y)} to {object_width, object_height}
		copy {(win_width - object_width - win_margin), (win_height - object_height - win_margin)} to {random_x_max, random_y_max}
		copy {(random number from win_margin to random_x_max), (random number from win_margin to random_y_max)} to {random_x, random_y}
		set position of the_object to {random_x, random_y}
		my update_status("new positon: {" & random_x & ", " & random_y & "}")
	end if
end mouse entered

on update_status(the_message)
	log the_message
end update_status